"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _HttpService = require("../components/services/HttpService");

var _HttpService2 = _interopRequireDefault(_HttpService);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AjaxPrinter = function AjaxPrinter(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, AjaxPrinter);

  this.initLayout = function () {
    var _props = _this.props,
        dialog = _props.dialog,
        ok = _props.ok,
        title = _props.title;

    console.log(!_this.layout);
    if (!_this.layout) {
      // this.layout = new CommonLayout({ dialog, title: title || "拍照", parent:this, ok });
      _this.topArea = $("<div class='snk-bh-croot-top'></div>");
      _this.createTopArea({ dialog: dialog, title: title || "打印" });

      _this.printBtn = $("<span class='snk-print-botton'>打印当前文件</span>");
      _this.printBtn.bind('click', function () {
        _this.doPrint('one');
      });
      _this.printAllBtn = $("<span class='snk-print-botton'>批量打印文件</span>");
      _this.printAllBtn.bind('click', function () {
        _this.doPrint('all');
      });
      var midArea = $("<div class='snk-print-body'></div>");
      var selectData = [{ type: 'printName', name: '选择目标打印机' }];
      for (var index = 0; index < selectData.length; index++) {
        var element = selectData[index];
        _this.createPrintList(midArea, element);
      }
      // this.createInput(midArea, { name: '打印份数', type: 'printNum' });
      midArea.append(_this.printBtn).append(_this.printAllBtn);
      _this.root.append(_this.topArea).append(midArea);
    }
  };

  this.createTopArea = function (_ref) {
    var title = _ref.title,
        dialog = _ref.dialog;
    var actionInstance = dialog.actionInstance;

    var closeBtn = $("<span class='snk-bh-header-close'>关闭</span>");
    closeBtn.bind('click', function () {
      if (actionInstance.cancelCheck()) {
        dialog.close();
      }
    });
    _this.title = $("<span class='snk-bh-header-title'>" + title + "</span>");
    _this.topArea.append(_this.title).append(closeBtn);
  };

  this.createPrintList = function (root, element) {
    var _that = _this;
    _this[element.type] = $('<select />');
    _this[element.type].bind('change', function (e) {
      var valIndex = e.target.value;
      _that._fillResolutionSelect(valIndex, element.type);
      _that.saveLocalData(element.type, valIndex);
    });
    var selectArea = $("<div class='snk-print-select-body'></div>");
    selectArea.append("<div class='snk-print-select-laber'>" + element.name + "</div>").append(_this[element.type]);
    root.append(selectArea);
  };

  this.createInput = function (root, element) {
    var _that = _this;
    _that[element.type] = $('<input class="snk-print-input" />');
    _that[element.type].bind('keydown', function (e) {
      if (e.keyCode === 13) {
        e.preventDefault();
        e.stopPropagation();
        _that[element.type].blur();
      }
    });
    _that[element.type].bind('blur', function () {
      var v = $.trim(_that[element.type].val());
      console.log(v);
      if (!v || !/^([1-9][0-9]{0,1}|0)$/.test(v)) {
        _that[element.type].val(1);
        _that._fillResolutionSelect(1, element.type);
      } else {
        _that[element.type].val(parseInt(v));
        _that._fillResolutionSelect(parseInt(v), element.type);
      }
    });
    var inputArea = $("<div class='snk-print-select-body'></div>");
    inputArea.append("<div class='snk-print-select-laber'>" + element.name + "</div>").append(_that[element.type]);
    root.append(inputArea);
    _that[element.type].val(parseInt(1));
  };

  this.cancelCheck = function () {
    // const re = this.getResult();
    // if(re.length ===0) {
    //   return true;
    // }
    // return window.confirm("存在操作记录，是否继续退出?");
    return true;
  };

  this.delUploadData = function (type) {
    // 处理上传参数
    var _that = _this;
    var _that$initParams = _that.initParams,
        urlData = _that$initParams.urlData,
        index = _that$initParams.index;

    if (!urlData) {
      return;
    }
    var initParamsLen = urlData.length;
    var newData = [];
    console.log(_that.upLoadData);
    var newObj = { filePaths: [], printerName: _that.upLoadData.printName, copies: '1' };
    if (type && type === 'one') {
      // 打印当前文件
      newObj.filePaths = [urlData[index || 0]];
      return newObj;
    }

    // 批量打印文件
    for (var index1 = 0; index1 < initParamsLen; index1 += 1) {
      newObj.filePaths = [urlData[index1]];
      newData.push(newObj);
    }
    return newData;
  };

  this.doPrint = function (type) {
    var _that = _this;
    var dialog = _this.props.dialog;

    if (_this.isPrintLoging) {
      return;
    }
    // const printName = _that.upLoadData.printName;
    // if (printName.includes('导出') || printName.includes('to PDF') || printName.includes('Foxit')) {
    //   alert(`不能使用-${printName}进行打印`);
    //   return;
    // }
    _that.showLoading();
    var upLoadData = _that.delUploadData(type);
    if (type === 'all' && (!upLoadData || upLoadData.length === 0) || type === 'one' && (!upLoadData.filePaths || upLoadData.filePaths.length === 0)) {
      alert('找不到打印文件');
      _that.hideLoading();
      return;
    }
    try {
      _HttpService2.default.evenloop(upLoadData, _HttpService2.default.doPrint, 0, function () {
        _that.hideLoading();
        alert('推送至打印机成功');
        dialog.close();
      }, function (errorData, index) {
        _that.hideLoading();
        console.log(errorData);
        if (errorData && errorData.code === 500 && errorData.message) {
          alert(errorData.message);
          dialog.close();
          // alert(`第${index + 1}个文件打印失败`)
        }
      });
    } catch (error) {
      console.log(error);
    }
    console.log(upLoadData);
  };

  this.logingFn = function (isLoging) {
    if (isLoging) {
      _this.isPrintLoging = isLoging;
      _this.printBtn.addClass('disabled');
      _this.printAllBtn.addClass('disabled');
    } else {
      _this.isPrintLoging = isLoging;
      _this.printBtn.removeClass('disabled');
      _this.printAllBtn.removeClass('disabled');
    }
  };

  this.saveLocalData = function (item, value) {
    // 持久化到浏览器中
    if (!item || !value) {
      console.error('请填写完整持久化信息');
    }
    var storageData = (0, _stringify2.default)(value);
    localStorage.setItem(item, storageData);
  };

  this.getLocalData = function (item) {
    // 获取浏览器中的持久化
    if (!item) {
      console.error('请填写完整持久化信息');
    }
    var storageData = localStorage.getItem(item);
    return JSON.parse(storageData);
  };

  this.fillSelects = function (data, component, type) {
    // 获得设备列表后回填
    var dialog = _this.props.dialog;
    var message = dialog.message;

    message.hide();
    dialog.wrapper.addClass('snk-bh-wrapper-print');
    component.empty();
    _this.cameraListDataSource = data;
    var index = 0;
    for (var i = 0, j = data.length; i < j; i += 1) {
      var MonikerString = data[i];
      if (MonikerString.includes('EPSON') || MonikerString.includes('Canon')) {
        index = i;
      }
      component.append("<option value='" + MonikerString + "'>" + MonikerString + "</option>");
    }
    var oldData = _this.getLocalData(type);
    component.val(oldData || data[index]);
    _this._fillResolutionSelect(oldData || data[index], type);
  };

  this._fillResolutionSelect = function (value, type) {
    // 保存选择的数据
    _this.upLoadData[type] = value;
  };

  this.onReciveMessage = function (jsonData) {
    var dialog = _this.props.dialog;

    if (jsonData) {
      if (jsonData.type === 'printName') {
        dialog.callDllLogicSuccess("callcamerasuccess");
        _this.reciveCamerList({ jsonData: jsonData });
      } else if (jsonData.type === 'Camera_Connect') {} else if (jsonData.type === 'Camera_GetImage') {} else if (jsonData.type === 'Get_Version') {
        console.log(jsonData.data);
      } else if (jsonData.type === 'Image_Ruihua') {
        // console.log(jsonData.imgId);
        _this.layout.midLeftArea.append($("<img src='" + jsonData.data + "'/>"));
      }
    }
  };

  this.getUpdateArea = function () {
    return _this.layout.bottomArea;
  };

  this.setErrorMessage = function (params) {
    var dialog = _this.props.dialog;
    var message = dialog.message;

    message.show(params);
  };

  this.showLoading = function (message1) {
    var dialog = _this.props.dialog;
    var message = dialog.message;

    message.show({
      isCloseDialog: true,
      html: message1 || '正在打印中...'
    });
  };

  this.hideLoading = function () {
    var dialog = _this.props.dialog;
    var message = dialog.message;

    message.hide();
  };

  this.showError = function () {
    _this.loadingWrapper.css({ "display": "flex" });
    _this.loadingWrapper.empty();
    _this.loadingWrapper.append($("<span>\u6253\u5370\u673A\u53EF\u80FD\u88AB\u5176\u4ED6\uFF08\u7A0B\u5E8F\u5E94\u7528\uFF0C\u7F51\u9875\uFF09\u5360\u7528,\u8BF7\u5173\u95ED\u76F8\u5173\u5E94\u7528\u7136\u540E\u91CD\u8BD5\uFF0C\u6216\u8005\u5207\u6362\u5176\u4ED6\u6444\u50CF\u5934\uFF01</span>"));
  };

  this.reciveCamerList = function (_ref2) {
    var jsonData = _ref2.jsonData;
    var code = jsonData.code,
        data = jsonData.data,
        message = jsonData.message,
        type = jsonData.type;

    if (code === 200) {
      if (data.length > 0) {
        _this.fillSelects(data, _this.printName, type);
        // this.fillSelects(['是', '否'], this.printTwoSide, 'printTwoSide');
        // this.fillSelects(['纵向', '横向'], this.printLayout, 'printLayout');
      } else {
        _this.setErrorMessage({
          isCloseDialog: true,
          html: "没有发现打印机相关设备,请准备好相关硬件然后重试！"
        });
      }
    } else {
      _this.setErrorMessage({
        isCloseDialog: true,
        html: message || "获取打印机信息失败！"
      });
    }
  };

  this.disConnect = function () {
    // if(this.ws) {
    //   try{
    //    this.ws.send(JSON.stringify({ action:'Camera_Close' }));
    //   }catch(e){}
    // }
    // this.clearGetImageInterval();
  };

  this.connectSuccess = function (_ref3) {
    var ws = _ref3.ws;

    _this.initLayout();
    _this.onReciveMessage({ type: 'printName', code: 200, data: ws });
  };

  this.hasClass = function (obj, cls) {
    return obj.className.match(new RegExp("(\\s|^)" + cls + "(\\s|$)"));
  };

  this.props = props;
  var initParams = this.props.initParams;

  this.root = $("<div class='snk-bh-camera-root'/>");
  this.initParams = initParams || [];
  this.upLoadData = {
    printName: null, // 打印机目标
    printSize: null, // 打印尺寸 如：A4
    printQuality: null, // 打印质量
    printLayout: null, // 打印布局 如：横向
    printTwoSide: null, // 打印是否双面，默认否
    printNum: 1 // 打印份数，默认为1份
  };
  this.isPrintLoging = false;
};

exports.default = AjaxPrinter;