"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _previewDialog = require("./cameraScannerImgList/previewDialog");

var _previewDialog2 = _interopRequireDefault(_previewDialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CommonLayout = function CommonLayout(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, CommonLayout);

  this.initLayout = function () {
    _this.root = $("<div class='snk-bh-croot'></div>");
    _this.topArea = $("<div class='snk-bh-croot-top'></div>");
    _this.createTopArea();
    var midArea = $("<div class='snk-bh-croot-mid'></div>");
    _this.midAreaInner = $("<div class='snk-bh-croot-mid-inner'></div>");
    _this.bottomArea = $("<div class='snk-bh-croot-bottom'></div>");
    _this.createBottomArea();
    var midLeftArea = $("<div class='snk-bh-croot-mid-left'></div>");
    _this.createLeftArea(midLeftArea);
    _this.midMidArea = $("<div class='snk-bh-croot-mid-mid'></div>");
    _this.midRightArea = $("<div class='snk-bh-croot-mid-right'></div>");
    midArea.append(_this.midAreaInner);
    _this.midAreaInner.append(midLeftArea).append(_this.midMidArea).append(_this.midRightArea);
    _this.root.append(_this.topArea).append(midArea).append(_this.bottomArea);
  };

  this.showPreview = function (item) {
    var dialog = _this.props.dialog;
    var actionInstance = dialog.actionInstance;

    if (!_this.previewDialogInstance) {
      _this.previewDialogInstance = new _previewDialog2.default();
      _this.root.append(_this.previewDialogInstance.root);
      _this.root.append(_this.previewDialogInstance.header);
    }
    _this.previewDialogInstance.show(item);
    if (actionInstance.onShowPreView) {
      actionInstance.onShowPreView();
    }
  };

  this.hidePreview = function () {
    if (_this.previewDialogInstance) {
      _this.previewDialogInstance.hide();
    }
  };

  this.createLeftArea = function (wrapper) {
    var leftTitleWrapper = $("<div class='snk-bh-croot-mid-left-top'></div>");
    _this.secondTitle = $("<span></span>");
    leftTitleWrapper.append(_this.secondTitle);
    _this.midLeftArea = $("<div class='snk-bh-croot-mid-left-bottom'></div>");
    wrapper.append(leftTitleWrapper).append(_this.midLeftArea);
  };

  this.setSecondTitle = function (str) {
    _this.secondTitle.empty();
    _this.secondTitle.append(str);
  };

  this.createTopArea = function () {
    var _props = _this.props,
        title = _props.title,
        dialog = _props.dialog;
    var actionInstance = dialog.actionInstance;

    var closeBtn = $("<span class='snk-bh-header-close'>关闭</span>");
    closeBtn.bind('click', function () {
      if (actionInstance.cancelCheck()) {
        dialog.close();
      }
    });
    _this.title = $("<span class='snk-bh-header-title'>" + title + "</span>");
    _this.topArea.append(_this.title).append(closeBtn);
  };

  this.createBottomArea = function () {
    var _props2 = _this.props,
        dialog = _props2.dialog,
        parent = _props2.parent,
        ok = _props2.ok;
    var actionInstance = dialog.actionInstance;

    var btnCancel = $("<button class='snk-bh-croot-cancelbtn' >取消</button>");
    btnCancel.bind('click', function () {
      if (actionInstance.cancelCheck()) {
        dialog.close();
      }
    });
    _this.btnOk = $("<button class='snk-bh-croot-okbtn' disabled='disabled'>确定</button>");
    _this.btnOk.bind("click", function () {
      var re = actionInstance.okClick();
      if (re !== false) {
        ok({ result: re });
        dialog.close();
      }
    });

    var openHistoryBtn = $("<span title='打开查看本地电脑历史操作图片保存位置（只保留最近五天的操作）' class='snk-bwh-openhistory'>查看本地记录</span>");
    openHistoryBtn.bind('click', function () {
      if (parent.ws) {
        parent.ws.send((0, _stringify2.default)({ action: 'Open_Folder' }));
      }
    });
    _this.bottomArea.append(openHistoryBtn).append(btnCancel).append(_this.btnOk);
  };

  this.setOkBtnState = function (resultLength) {
    if (resultLength === 0) {
      _this.btnOk.attr("disabled", "disabled");
    } else {
      _this.btnOk.removeAttr("disabled");
    }
  };

  this.props = props;
  this.initLayout();
};

exports.default = CommonLayout;