'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _ajaxPrinter = require('./ajax-printer');

var _ajaxPrinter2 = _interopRequireDefault(_ajaxPrinter);

var _message = require('./message');

var _message2 = _interopRequireDefault(_message);

var _protocolcheck = require('./protocolcheck');

var _protocolcheck2 = _interopRequireDefault(_protocolcheck);

var _HttpService = require('../components/services/HttpService');

var _HttpService2 = _interopRequireDefault(_HttpService);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Dialog = function Dialog(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, Dialog);

  this.callDllLogicSuccess = function (step) {
    _this.step = step;
  };

  this.initLayout = function () {
    var _props = _this.props,
        action = _props.action,
        ok = _props.ok,
        env = _props.env,
        token = _props.token,
        initParams = _props.initParams,
        reStartCallBack = _props.reStartCallBack,
        title = _props.title,
        hideLianPai = _props.hideLianPai,
        hostUrl = _props.hostUrl;

    _this.message = new _message2.default({ dialog: _this, env: env, reStartCallBack: reStartCallBack, downLoadHost: hostUrl });
    _this.bk = $('<div class=\'snk-bh-bk snk-bh-bk-' + action + '\'></div>');
    _this.wrapper = $('<div class=\'snk-bh-wrapper snk-bh-wrapper-' + action + '\'></div>');
    if (action === 'ajax-print') {
      // ajax请求插件
      _this.actionInstance = new _ajaxPrinter2.default({ dialog: _this, ok: ok, env: env, initParams: initParams, token: token });
    }
    _this.wrapper.append(_this.message.root).append(_this.actionInstance.root);
  };

  this.getResult = function () {
    return _this.actionInstance.getResult();
  };

  this.clearConnectTimeout = function () {
    if (_this.connectTimeoutID) {
      window.clearTimeout(_this.connectTimeoutID);
      _this.connectTimeoutID = null;
    }
  };

  this.connect = function () {
    var _props2 = _this.props,
        port = _props2.port,
        env = _props2.env,
        action = _props2.action;

    _this.clearConnectTimeout();
    _this.checkUpdateSuccess = false;
    _this.limitMax = 20;
    _this.message.showLoading('\u6B63\u5728\u68C0\u6D4B\u672C\u5730\u786C\u4EF6\u73AF\u5883(' + Math.floor(_this.tryConnectCount / 2) + '/' + _this.limitMax / 2 + ')\u3002<br />\n    \u5982\u679C\u8FD8\u6CA1\u6709\u5B89\u88C5\u6253\u5370\u52A9\u624B,\u8BF7\u70B9\u51FB\u6839\u636E\u7535\u8111\u7CFB\u7EDF\u4E0B\u8F7D\u5B89\u88C5:</span><br />\n    (<a style=\'font-weight:bold;\' download href=\'' + _this.message.dowloadURL + '\'>Win 64\u4F4D</a>)\u3001(<a style=\'font-weight:bold;\' download href=\'' + _this.message.dowloadURL1 + '\'>Win 32\u4F4D</a>)\n    <br /><span style=\'color:red\'>\u5B89\u88C5\u8FD0\u884C\u540E\u518D\u91CD\u8BD5</span>');
    _this.tryConnectCount += 1;
    _this.connectTimeoutID = window.setTimeout(function () {
      if (_this.tryConnectCount > _this.limitMax) {
        _this.showConnectError();
        return;
      }
      if (action === 'ajax-print') {
        var _that = _this;
        // this.message.hide();
        // _that.connectSuccess([1, 2, 3]);
        _HttpService2.default.getPrintList().then(function (data) {
          _that.connectSuccess(data);
          _that.clearConnectTimeout();
        }).catch(function () {
          _that.disConnect();
        });
      }
      if (!_this.websocketInstance) {
        return;
      }
    }, _this.timeoutArr[_this.tryConnectCount] || 1000);
  };

  this.disposeConnect = function () {
    _this.clearConnectTimeout();
    _this.actionInstance.disConnect();
    if (_this.websocketInstance) {
      _this.websocketInstance.onclose = function () {};
      _this.websocketInstance.close();
      _this.websocketInstance = null;
    }
  };

  this.disConnect = function () {
    if (_this.tryConnectCount === 1) {
      _this.callElectron();
    }
    window.onbeforeunload = function () {};
    _this.clearConnectTimeout();
    if (_this.succeeded) {
      _this.succeeded = false;
      _this.message.showDisConnect();
    } else {
      _this.connect();
    }
    _this.actionInstance.ws = null;
    _this.actionInstance.disConnect();
  };

  this.callElectron = function () {
    var _props3 = _this.props,
        port = _props3.port,
        env = _props3.env,
        action = _props3.action,
        callElectronCallBack = _props3.callElectronCallBack;

    var app = action === 'ajax-print' ? 'haprinthandler' : 'snkwebhelper';
    var str = app + '://?port=' + port + '&action=' + action + '&env=' + env + '}';
    if (callElectronCallBack) {
      // 因为从iframe唤起的话会报跨域 那么就让程序决定 让上一级去唤起
      callElectronCallBack(str);
    } else {
      (0, _protocolcheck2.default)(str, // 检测有无安装
      function () {});
    }
  };

  this.onReciveMessage = function (e, ws) {
    var data = e.data;
    var jsonData = null;
    try {
      jsonData = JSON.parse(data);
      var _jsonData = jsonData,
          action = _jsonData.action,
          code = _jsonData.code,
          reData = _jsonData.data,
          reMessage = _jsonData.message;

      console.log(action + "  >>>>>>>>>>>");
      if (action === 'App_Update') {} else if (action === 'GLOBAL') {
        _this.hasError = true;
        if (reMessage && reMessage.indexOf('The specified module could not be found') >= 0) {
          // 缺少vc++ 2015
          _this.message.showDownloadVC();
        } else {
          _this.message.show({
            isCloseDialog: true,
            html: reMessage || '~'
          });
        }
      } else if (action === "App_Check_Update") {
        if (reData === true) {
          _this.showHasUpdate({ ws: ws, message: _this.message, topArea: _this.actionInstance.getUpdateArea() });
        }
      }
    } catch (e) {
      jsonData = null;
    }

    if (!_this.hasError) {
      _this.actionInstance.onReciveMessage(e, jsonData);
    }
  };

  this.showHasUpdate = function (_ref) {
    var ws = _ref.ws,
        message = _ref.message,
        topArea = _ref.topArea;

    if (_this.hasCreateUpdateBtn === true) {
      return;
    }
    var slable = $("<span class='blink snk-wbh-update-label'>检测到新版本</span>");
    var updateBtn = $("<span class='snk-wbh-update-btn'>点击更新</span>");
    updateBtn.bind("click", function () {
      if (window.confirm("确定更新吗?")) {
        message.showLoading("正在更新....");
        updateBtn.hide();
        slable.hide();
        ws.send((0, _stringify2.default)({ action: 'App_Update', data: {} }));
      }
    });
    topArea.append(slable).append(updateBtn);
    _this.hasCreateUpdateBtn = true;
  };

  this.connectSuccess = function (ws) {
    _this.clearConnectTimeout();
    _this.succeeded = true;
    _this.tryConnectCount = 0;
    _this.hasSuccessCount += 1;
    _this.actionInstance.connectSuccess({ ws: ws });
    window.onbeforeunload = function () {
      _this.disposeConnect();
    };
  };

  this.showConnectError = function () {
    _this.clearConnectTimeout();
    _this.message.showCallElectronFail();
  };

  this.show = function () {
    _this.tryConnectCount = 0;
    $(document.body).append(_this.bk).append(_this.wrapper);
    _this.connect();
  };

  this.reStart = function () {
    _this.tryConnectCount = 0;
    _this.connect();
  };

  this.close = function () {
    var close = _this.props.close;

    _this.disposeConnect();
    _this.bk.remove();
    _this.wrapper.remove();
    if (close) {
      close();
    }
  };

  this.props = props;
  this.connectTimeoutID = null;
  this.succeeded = false;
  this.actionInstance = null;
  this.tryConnectCount = 0;
  this.hasSuccessCount = 0;
  this.websocketInstance = null;
  this.hasError = false;
  this.step = 'init';
  this.initLayout();
  this.timeoutArr = [1, 1, 500, 750, 800, 800];
};

exports.default = Dialog;