"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SNKDOM = function SNKDOM() {
  var _this = this;

  (0, _classCallCheck3.default)(this, SNKDOM);

  this.setJquery = function ($) {
    _this.$ = $;
  };

  this.bind = function (config) {
    var dom = config.dom,
        type = config.type,
        callback = config.callback,
        stop = config.stop,
        prevent = config.prevent;

    if (dom.addEventListener) {
      dom.addEventListener(type, function (e) {
        if (stop) {
          e.stopPropagation();
        }
        if (prevent) {
          e.preventDefault();
        }
        callback(e);
      });
    } else if (!_this.$) {
      dom.attachEvent("on" + type, function (e) {
        if (stop) {
          window.event.returnValue = false;
        }
        if (prevent) {
          window.event.returnValue = false;
        }
        callback(e);
      });
    } else {
      _this.$(dom).bind(type, function (e) {
        if (stop) {
          e.stopPropagation();
        }
        if (prevent) {
          e.preventDefault();
        }
        callback(e);
      });
    }
  };
};

exports.default = new SNKDOM();