"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Comfirm = function Comfirm(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, Comfirm);

  this.show = function (_ref) {
    var wrapper = _ref.wrapper,
        buttons = _ref.buttons,
        renderContent = _ref.renderContent,
        title = _ref.title,
        contentClassName = _ref.contentClassName,
        init = _ref.init;

    var _wrapper = wrapper || document.body;
    _this.root = $("<div class='snk-bh-comfirm-root-out'>");
    _this.inner = $("<div class='snk-bh-comfirm-root'>");
    if (title) {
      var top = $("<div class='snk-bh-comfirm-title'><span>" + title + "</span></div>");
      _this.inner.append(top);
    }
    var content = $("<div class='" + (contentClassName || 'snk-bh-comfirm-content') + "'/>");
    if (renderContent) {
      renderContent(content, _this);
    }
    _this.inner.append(content);
    _this.root.append(_this.inner);
    _this.buttons = [];
    _this.bk = $("<div class='snk-bh-comfirm-bk'>");
    if (buttons && buttons.length > 0) {
      var buttnWrapper = $("<div class='snk-bh-comfirm-buttonwraper'>");

      var _loop = function _loop(i, j) {
        var _buttons$i = buttons[i],
            _buttons$i$title = _buttons$i.title,
            title = _buttons$i$title === undefined ? 'title' : _buttons$i$title,
            cb = _buttons$i.cb,
            isMain = _buttons$i.isMain;

        var btn = $("<button class='snk-bh-comfirm-btn " + (isMain ? 'snk-bh-comfirm-okbtn' : 'snk-bh-comfirm-cancelbtn') + "'>" + title + "</button>");
        btn.bind('click', function () {
          cb(_this);
        });
        _this.buttons.push(btn);
        buttnWrapper.append(btn);
      };

      for (var i = 0, j = buttons.length; i < j; i += 1) {
        _loop(i, j);
      }
      _this.inner.append(buttnWrapper);
    }
    $(_wrapper).append(_this.root).append(_this.bk);
    if (init) {
      init(_this);
    }
  };

  this.getButton = function (index) {
    return _this.buttons[index];
  };

  this.hide = function () {
    _this.root.remove();
    _this.bk.remove();
  };
};

exports.default = Comfirm;