'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dom = require('../dom');

var _dom2 = _interopRequireDefault(_dom);

require('./index.less');

var _item = require('./item');

var _item2 = _interopRequireDefault(_item);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

var _thumbBar = require('./thumbBar');

var _thumbBar2 = _interopRequireDefault(_thumbBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var transformInfo = _util2.default.getTransitionKeys();
var isSupportTouch = "ontouchend" in document ? true : false;
var eventDict = {
    start: isSupportTouch ? 'touchstart' : 'mousedown',
    move: isSupportTouch ? 'touchmove' : 'mousemove',
    end: isSupportTouch ? 'touchend' : 'mouseup',
    cancel: isSupportTouch ? 'touchcancel' : 'mouseleave'
};

var Slide = function () {
    function Slide(props) {
        var _this = this;

        (0, _classCallCheck3.default)(this, Slide);

        _initialiseProps.call(this);

        this.props = props || {};
        var _props = this.props,
            zIndex = _props.zIndex,
            isLoop = _props.isLoop;

        this.offset = 0;
        this.isShow = false;
        this.isLoop = !!isLoop;
        this.currentIndex = 0;
        this.isInTransition = false;
        this.root = document.createElement("DIV");
        this.root.className = 'snk-slide-root';
        this.root.style.display = 'none';
        this.root.style.zIndex = zIndex || 1000;
        this.bk = document.createElement('DIV');
        this.bk.className = 'snk-slide-bk';
        this.bk.style.zIndex = zIndex - 11 || 800;
        this.bk.style.display = 'none';
        this.touchLimit = 60;
        this.touchDisabled = false;
        var innerWrapper = document.createElement("DIV");
        innerWrapper.className = 'snk-slide-inner';
        this.itemArrary = [];
        this._createActionWrapper(innerWrapper);
        this._createItemsWrapper(innerWrapper);
        this._createThumbBar(innerWrapper);
        this.root.appendChild(innerWrapper);
        document.body.appendChild(this.bk);
        document.body.appendChild(this.root);
        window.onresize = _util2.default.throttle(function () {
            if (!_this.isShow) {
                return;
            }
            _this.wrapperWidth = _this.root.offsetWidth;
            _this.wrapperHeight = _this.root.offsetHeight;
            _this.setPos();
            for (var i = 0, j = _this.itemArrary.length; i < j; i += 1) {
                _this.itemArrary[i].onResize({
                    width: _this.wrapperWidth,
                    height: _this.wrapperHeight
                });
            }
        }, 400);
        this._bindEvent();
        this._createCloseBtn();
    }

    (0, _createClass3.default)(Slide, [{
        key: 'getPreSourceArr',
        value: function getPreSourceArr() {
            var len = this.data.length;
            var mid = this.sourceArr[1];
            mid -= 1;
            if (mid < 0) {
                if (this.isLoop) {
                    mid = len === 1 ? 0 : len - 1;
                } else {
                    mid += 1;
                }
            }
            var lr = this.getLeftRightIndexByMid(mid, len);
            var arr = [lr.left, mid, lr.right, lr.rightright];
            this.sourceArr = arr;
        }
    }, {
        key: 'getNextSourceArr',
        value: function getNextSourceArr() {
            var len = this.data.length;
            var mid = this.sourceArr[1];
            mid += 1;
            if (mid > len - 1) {
                if (this.isLoop) {
                    mid = len === 0 ? -1 : 0;
                } else {
                    mid -= 1;
                }
            }
            var lr = this.getLeftRightIndexByMid(mid, len);
            var arr = [lr.left, mid, lr.right, lr.rightright];
            this.sourceArr = arr;
        }
    }, {
        key: 'getLeftRightIndexByMid',
        value: function getLeftRightIndexByMid(mid, len) {
            var right;
            if (mid === -1) {
                right = -1;
            } else {
                right = mid + 1;
                if (right > len - 1) {
                    if (this.isLoop) {
                        right = len === 1 ? -1 : 0;
                    } else {
                        right = -1;
                    }
                }
            }

            var rightright = -1;
            if (right === -1) {
                rightright = -1;
            } else {
                rightright = right + 1;
                if (rightright > len - 1) {
                    if (this.isLoop) {
                        rightright = len === 1 ? -1 : 0;
                    } else {
                        rightright = -1;
                    }
                }
            }

            var left = mid - 1;
            if (left < 0) {
                if (this.isLoop) {
                    left = len === 1 ? -1 : len - 1;
                } else {
                    left = -1;
                }
            }
            return { left: left, right: right, rightright: rightright };
        }
    }]);
    return Slide;
}();

var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this._createActionWrapper = function (innerWrapper) {
        var renderTopActionArea = _this2.props.renderTopActionArea;

        if (!renderTopActionArea) {
            return;
        }
        _this2.topActionArea = document.createElement("DIV");
        _this2.topActionArea.className = 'snk-slide-action-wrapper';
        innerWrapper.appendChild(_this2.topActionArea);
        renderTopActionArea({
            wrapper: _this2.topActionArea,
            instance: _this2
        });
    };

    this._createCloseBtn = function () {
        // const closeBtn = document.createElement("DIV");
        // closeBtn.className = 'snk-slide-close';
        // SNKDom.bind({
        //     type: 'click',
        //     dom: closeBtn,
        //     callback: () => {
        //         this.hide();
        //     },
        // });
        // this.topActionArea.appendChild(closeBtn);
    };

    this._createItemsWrapper = function (innerWrapper) {
        _this2.itemsWrapper = document.createElement("DIV");
        _this2.itemsWrapper.className = 'snk-slide-item-wrapper';
        var itemsWrapperInner = document.createElement("DIV");
        itemsWrapperInner.className = 'snk-slide-item-wrapper-inner';
        for (var i = 0; i < 3; i += 1) {
            var item = new _item2.default({
                wrapper: itemsWrapperInner,
                isSupportTouch: isSupportTouch,
                slide: _this2,
                eventDict: eventDict
            });
            var itemStyle = {};
            itemStyle['left'] = 100 * (i - 1) + '%';
            item.setStyle(itemStyle);
            _this2.itemArrary[i] = item;
        }
        _this2.itemsWrapper.appendChild(itemsWrapperInner);
        innerWrapper.appendChild(_this2.itemsWrapper);
    };

    this._createThumbBar = function (innerWrapper) {
        if (!_this2.props.thumbBarPosition) {
            return;
        }
        _this2.thumbBarInstance = new _thumbBar2.default({
            wrapper: innerWrapper,
            slide: _this2,
            itemsWrapper: _this2.itemsWrapper,
            postion: _this2.props.thumbBarPosition
        });
    };

    this.changeByDataItem = function (data) {
        for (var i = 0, j = _this2.data.length; i < j; i += 1) {
            if (_this2.data[i] === data) {
                _this2.setSelectedByIndex(i);
                break;
            }
        }
    };

    this.getCurrentData = function () {
        return _this2.data[_this2.currentIndex];
    };

    this.getCurrentItem = function () {
        console.log(">>>>>>>>>>>>>>>");
        console.log(_this2.sourceArr);
        console.log(_this2.currentIndex);
        console.log(_this2.itemArrary);
        return _this2.itemArrary[1];
    };

    this.currentIsLast = function () {
        if (_this2.data.length === 0) {
            return true;
        }
        if (_this2.currentIndex >= _this2.data.length - 1) {
            return true;
        }
        return false;
    };

    this.currentIsFirst = function () {
        if (_this2.data.length === 0) {
            return true;
        }
        if (_this2.currentIndex === 0) {
            return true;
        }
        return false;
    };

    this.setSelectedByIndex = function (_index) {
        _this2.currentIndex = _index;
        if (isNaN(_this2.currentIndex)) {
            _this2.currentIndex = 0;
        }
        _this2.currentIndex = parseInt(_this2.currentIndex);
        if (_this2.currentIndex >= _this2.data.length) {
            _this2.currentIndex = 0;
        }
        _this2.sourceArr = [-1, _this2.currentIndex - 1, -1];
        _this2.getNextSourceArr();
        _this2.bindDataSource();
        _this2.onChange({
            isInit: true,
            index: _this2.currentIndex,
            slide: _this2
        });
    };

    this._getTouchPos = function (e) {
        if (isSupportTouch) {
            var touches = e.touches[0];
            return {
                x: touches.pageX,
                y: touches.pageY
            };
        } else {
            return {
                x: e.pageX || e.screenX,
                y: e.pageY || e.screenY
            };
        }
    };

    this._bindEvent = function () {
        var startPointer = {},
            startTime = 0,
            startOffset = 0,
            isTouch = false,
            diffX = void 0;
        _dom2.default.bind({
            type: eventDict.start,
            dom: _this2.itemsWrapper,
            callback: function callback(e) {
                if (_this2.touchDisabled) {
                    return;
                }

                // if(e.offsetX > this.wrapperWidth - 22) {
                //     // ie 滚动条
                //     return;
                // }
                // if(e.offsetY > this.wrapperHeight - 22) {
                //     return;
                // }

                e.preventDefault && e.preventDefault();
                if (_this2.isInTransition) {
                    return;
                }
                startPointer = _this2._getTouchPos(e);
                startTime = new Date().valueOf();
                startOffset = _this2.offset;
                isTouch = true;
                diffX = 0;
            }
        });
        _dom2.default.bind({
            dom: _this2.itemsWrapper,
            type: eventDict.move,
            prevent: true,
            callback: function callback(e) {
                if (_this2.touchDisabled || !_this2.sourceArr) {
                    return;
                }

                if (_this2.isInTransition) {
                    return;
                }
                if (!isTouch) {
                    return;
                }

                var curPointer = _this2._getTouchPos(e);
                diffX = curPointer.x - startPointer.x + startOffset;
                if (diffX > 0) {
                    if (_this2.sourceArr[0] === -1) {
                        diffX = 0;
                        return;
                    }
                } else {
                    if (_this2.sourceArr[2] === -1) {
                        diffX = 0;
                        return;
                    }
                }
                _this2.setPos(diffX);
            }
        });
        _dom2.default.bind({
            dom: _this2.itemsWrapper,
            type: eventDict.end,
            callback: function callback(e) {
                if (_this2.isInTransition) {
                    return;
                }
                touchEnd();
                diffX = 0;
            }
        });
        var touchEnd = function touchEnd() {
            if (_this2.touchDisabled) {
                return;
            }
            if (diffX > 0) {
                // 右
                if (diffX > _this2.touchLimit) {
                    _this2.goPre();
                } else {
                    _this2._reset();
                }
            } else if (diffX < 0) {
                // 左
                if (Math.abs(diffX) > _this2.touchLimit) {
                    _this2.goNext();
                } else {
                    _this2._reset();
                }
            }
            isTouch = false;
        };

        _dom2.default.bind({
            dom: _this2.itemsWrapper,
            type: eventDict.cancel,
            callback: function callback(e) {
                if (_this2.isInTransition) {
                    return;
                }
                touchEnd();
                diffX = 0;
            }
        });
    };

    this._reset = function () {
        _this2.isInTransition = true;
        _this2.setPos(0, true);
        setTimeout(function () {
            _this2.isInTransition = false;
        }, 300);
    };

    this.goPre = function () {
        _this2.isInTransition = true;
        _this2.setPos(_this2.wrapperWidth, true);
        _this2._transitionEnd(true);
    };

    this.goNext = function () {
        _this2.isInTransition = true;
        _this2.setPos(0 - _this2.wrapperWidth, true);
        _this2._transitionEnd(false);
    };

    this._transitionEnd = function (isPre) {
        setTimeout(function () {
            if (isPre) {
                var re = _this2.itemArrary.pop();
                _this2.itemArrary.unshift(re);
                _this2.getPreSourceArr();
            } else {
                var _re = _this2.itemArrary.shift();
                _this2.itemArrary.push(_re);
                _this2.getNextSourceArr();
            }
            if (_this2.currentIndex !== _this2.sourceArr[1]) {
                _this2.currentIndex = _this2.sourceArr[1];
                _this2.onChange({
                    isInit: false,
                    index: _this2.currentIndex,
                    slide: _this2
                });
            }
            _this2.bindDataSource();
            _this2.offset = 0;
            _this2.setPos(0);
            _this2.isInTransition = false;
        }, 300);
    };

    this.bindDataSource = function () {
        for (var i = 0, j = _this2.itemArrary.length; i < j; i += 1) {
            var item = _this2.itemArrary[i];
            var sourceIndex = _this2.sourceArr[i];
            var source = _this2.data[sourceIndex];
            item.bind({
                data: source
            });
        }
    };

    this.onChange = function (params) {
        var onChange = _this2.props.onChange;

        if (_this2.thumbBarInstance) {
            _this2.thumbBarInstance.onChange(params);
        }
        var index = params.index;

        if (onChange) {
            onChange({ index: index, data: _this2.data[index], slide: _this2 });
        }
    };

    this.hide = function () {
        _this2.root.style.display = 'none';
        _this2.bk.style.display = 'none';
        _this2.isShow = false;
    };

    this.show = function (params) {
        _this2._show(params);
    };

    this.update = function (_ref) {
        var data = _ref.data;

        if (!_this2.isShow) {
            return;
        }
        var index = _this2.currentIndex - 1 < 0 ? 0 : _this2.currentIndex - 1;
        _this2._show({
            data: data,
            index: index
        });
    };

    this._show = function (params) {
        _this2.isShow = true;
        _this2.data = params.data || [];
        if (_this2.data.length === 0) {
            _this2.root.style.display = 'block';
            // alert('todo .. empty');
            return;
        }
        _this2.thumbBarInstance && _this2.thumbBarInstance.show({
            data: _this2.data
        });
        _this2.setSelectedByIndex(params.index);
        _this2.root.style.display = 'block';
        _this2.bk.style.display = 'block';
        _this2.wrapperWidth = _this2.root.offsetWidth;
        _this2.wrapperHeight = _this2.root.offsetHeight;
        _this2.setPos();
    };

    this.getThumbItemByIndex = function (index) {
        return _this2.thumbBarInstance.getThumbItemByIndex(index);
    };

    this.setPos = function (offset, isAnimate) {
        offset = offset || 0;
        _this2.offset = offset;
        for (var i = 0; i < 3; i += 1) {
            var itemStyle = {};
            var item = _this2.itemArrary[i];
            if (isAnimate === true) {
                itemStyle[transformInfo.transition] = 'left .3s ease';
            } else {
                itemStyle[transformInfo.transition] = '';
            }
            itemStyle['left'] = (i - 1) * _this2.wrapperWidth + offset + 'px';
            item.setStyle(itemStyle);
        }
    };
};

exports.default = Slide;