'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _imageItem = require('./imageItem');

var _imageItem2 = _interopRequireDefault(_imageItem);

var _videoItem = require('./videoItem');

var _videoItem2 = _interopRequireDefault(_videoItem);

var _pdfItem = require('./pdfItem');

var _pdfItem2 = _interopRequireDefault(_pdfItem);

var _notSupportItem = require('./notSupportItem');

var _notSupportItem2 = _interopRequireDefault(_notSupportItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Item = function Item(props) {
    var _this = this;

    (0, _classCallCheck3.default)(this, Item);

    this.setStyle = function (style) {
        for (var key in style) {
            _this.root.style[key] = style[key];
        }
    };

    this.onResize = function (size) {
        if (_this.itemInstance && _this.itemInstance.onResize) {
            _this.itemInstance.onResize(size);
        }
    };

    this.bind = function (params) {
        if (params.data && _this.data !== params.data) {
            var _props = _this.props,
                slide = _props.slide,
                isSupportTouch = _props.isSupportTouch,
                eventDict = _props.eventDict;

            _this.data = params.data || {};
            var src = _this.data.src || '';
            if (slide.props.getSrc) {
                src = slide.props.getSrc({
                    data: _this.data
                });
            }
            var subfix = void 0;
            var ItemClass = _notSupportItem2.default;
            if (slide.props.getFileType) {
                var type = slide.props.getFileType({
                    src: src,
                    data: _this.data
                });
                if (type) {
                    subfix = type;
                }
            }
            if (!subfix) {
                var srcArr = src.split(".");
                subfix = srcArr[srcArr.length - 1].toLowerCase();
                subfix = subfix.split('?')[0];
            }
            if (['jpg', 'png', 'gif', 'jpeg', 'bmp'].indexOf(subfix) >= 0) {
                ItemClass = _imageItem2.default;
            } else if (['pdf'].indexOf(subfix) >= 0) {
                ItemClass = _pdfItem2.default;
            } else if (['mp4', 'rmvb'].indexOf(subfix) >= 0) {
                ItemClass = _videoItem2.default;
            }
            _this.root.innerHTML = '';
            _this.itemInstance = new ItemClass({
                src: src,
                data: _this.data,
                slide: slide,
                isSupportTouch: isSupportTouch,
                parent: _this,
                eventDict: eventDict
            });
            _this.root.appendChild(_this.itemInstance.root);
        }
    };

    this.props = props;
    this.root = document.createElement("DIV");
    this.root.className = 'snk-slide-item';
    props.wrapper.appendChild(this.root);
};

exports.default = Item;