'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _thumbItem = require('./thumbItem');

var _thumbItem2 = _interopRequireDefault(_thumbItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ThumbBar = function ThumbBar(props) {
    (0, _classCallCheck3.default)(this, ThumbBar);

    _initialiseProps.call(this);

    this.props = props || {};
    var _props = this.props,
        itemsWrapper = _props.itemsWrapper,
        postion = _props.postion,
        wrapper = _props.wrapper;

    if (['bottom', 'left', 'top', 'right'].indexOf(postion) < 0) {
        postion = 'left';
    }
    this.thumbWrapper = document.createElement("DIV");
    this.thumbWrapper.className = 'snk-slide-thumb-wrapper snk-slide-thumb-wrapper-' + postion;
    itemsWrapper.className = 'snk-slide-item-wrapper-' + postion;
    wrapper.appendChild(this.thumbWrapper);
    this.itemsArr = [];
};

var _initialiseProps = function _initialiseProps() {
    var _this = this;

    this.onChange = function (params) {
        var selectedIndex = params.index;
        for (var i = 0, j = _this.itemsArr.length; i < j; i += 1) {
            _this.itemsArr[i].setSelected(i === selectedIndex);
        }
    };

    this.getThumbItemByIndex = function (index) {
        return _this.itemsArr[index];
    };

    this.show = function (props) {
        var data = props.data;

        if (data.length === 0) {
            return;
        }
        _this.thumbWrapper.innerHTML = '';
        _this.itemsArr = [];
        for (var i = 0, j = data.length; i < j; i += 1) {
            var item = new _thumbItem2.default({
                data: data[i],
                bar: _this,
                slide: _this.props.slide,
                wrapper: _this.thumbWrapper
            });
            _this.itemsArr.push(item);
            _this.thumbWrapper.appendChild(item.root);
        }
    };
};

exports.default = ThumbBar;