'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _dom = require('../../dom');

var _dom2 = _interopRequireDefault(_dom);

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultSrcDict = {
    // pdf: require('../../snkpcimgs/FileExt_pdf.png'),
    // media: require('../../snkpcimgs/FileExt_pdf.png'),
    // other:require('../../snkpcimgs/FileExt_pdf.png'),
};

var ThumbItem =
// 
function ThumbItem(props) {
    var _this = this;

    (0, _classCallCheck3.default)(this, ThumbItem);

    this.setStyle = function (style) {
        for (var key in style) {
            _this.root.style[key] = style[key];
        }
    };

    this.setSelected = function (selected) {
        if (selected) {
            setTimeout(function () {
                if (_this.root.scrollIntoViewIfNeeded) {
                    _this.root.scrollIntoViewIfNeeded();
                } else {
                    _this.root.scrollIntoView();
                }
            }, 100);
        }
        _this.root.className = selected ? 'snk-slide-thumb-item snk-slide-thumb-item-selected' : 'snk-slide-thumb-item';
    };

    this.bind = function () {
        if (_this.loadSuccess) {
            return;
        }
        _this.img = new Image();
        _this.img.className = 'snk-slide-thumb-img';
        _this.img.src = _this.src;
        _this.img.style.transform = 'rotate(' + _this.rotateValue + 'deg)';
        _this.img.onload = function () {
            _this.root.innerHTML = '';
            _this.root.appendChild(_this.img);
        };
    };

    this.rotate = function (value) {
        _this.rotateValue = _this.rotateValue + value;
        if (_this.rotateValue >= 360) {
            _this.rotateValue = 0;
        }
        if (_this.rotateValue === -90) {
            _this.rotateValue = 270;
        }
        _this.img.style.transform = 'rotate(' + _this.rotateValue + 'deg)';
    };

    this.init = function () {
        var slide = _this.props.slide;

        _this.data = _this.props.data || {};
        var item = _this.data.item;
        var snkrotateValue = item.Vo.snkrotateValue;

        _this.rotateValue = snkrotateValue || 0;
        var src = _this.data.src || '';
        if (slide.props.getSrc) {
            src = slide.props.getSrc({
                data: _this.data
            });
        }
        var thumbSrc = _this.data.thumbSrc;
        if (slide.props.getThumb) {
            thumbSrc = slide.props.getThumb({
                data: _this.data
            });
        }
        _this.needLazyLoad = false;
        var subfix = void 0;
        var srcArr = src.split(".");
        subfix = srcArr[srcArr.length - 1].toLowerCase();
        subfix = subfix.split('?')[0];
        if (slide.props.getFileType) {
            var type = slide.props.getFileType({
                src: src,
                subfix: subfix,
                data: _this.data
            });
            if (type) {
                subfix = type;
            }
        }
        var imgSrc = thumbSrc;
        if (['jpg', 'png', 'gif', 'jpeg', 'bmp'].indexOf(subfix) >= 0) {
            imgSrc = imgSrc || src;
            if (imgSrc) {
                _this.needLazyLoad = true;
            }
            _this.src = imgSrc;
        } else if (['pdf'].indexOf(subfix) >= 0) {
            _this.src = imgSrc || defaultSrcDict[subfix];
        } else if (['mp4', 'rmvb', 'mov'].indexOf(subfix) >= 0) {
            _this.src = imgSrc || defaultSrcDict['media'];
        } else {
            _this.src = imgSrc || defaultSrcDict['other'];
        }
        if (_this.src) {
            if (!imgSrc) {
                _this.root.style.background = 'url(' + _this.src + ') no-repeat center center';
                _this.root.style.backgroundSize = '80px 80px';
            } else {
                _this.bind();
            }
        }
    };

    this.props = props;
    this.root = document.createElement("DIV");
    this.root.className = 'snk-slide-thumb-item';
    this.loadSuccess = false;
    _dom2.default.bind({
        type: 'click',
        dom: this.root,
        callback: function callback() {
            _this.props.slide.changeByDataItem(_this.props.data);
        }
    });
    setTimeout(function () {
        _this.init();
    }, 20);
};

exports.default = ThumbItem;