'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var translateKeys;

var Re = {
    autoResizeImage: function autoResizeImage(maxWidth, maxHeight, w, h, objImg, rotate, rootWrapper) {
        var hRatio;
        var wRatio;
        var Ratio = 1;
        if (rotate === 90 || rotate === 270) {
            var tem = maxHeight;
            maxHeight = maxWidth;
            maxWidth = tem;
        }
        wRatio = maxWidth / w;
        hRatio = maxHeight / h;
        if (maxWidth == 0 && maxHeight == 0) {
            Ratio = 1;
        } else if (maxWidth == 0) {
            //
            if (hRatio < 1) {
                Ratio = hRatio;
            }
        } else if (maxHeight == 0) {
            if (wRatio < 1) {
                Ratio = wRatio;
            }
        } else if (wRatio < 1 || hRatio < 1) {
            Ratio = wRatio <= hRatio ? wRatio : hRatio;
        }
        if (Ratio < 1) {
            w = w * Ratio;
            h = h * Ratio;
        }
        var info = {
            width: w,
            height: h,
            left: 0,
            top: 0
        };
        objImg.style.height = h + 'px';
        objImg.style.width = w + 'px';
        if (rotate === 90 || rotate === 270) {
            var _objImg$getBoundingCl = objImg.getBoundingClientRect(),
                top = _objImg$getBoundingCl.top,
                left = _objImg$getBoundingCl.left,
                width = _objImg$getBoundingCl.width,
                height = _objImg$getBoundingCl.height;

            var _rootWrapper$getBound = rootWrapper.getBoundingClientRect(),
                rootTop = _rootWrapper$getBound.top,
                rootLeft = _rootWrapper$getBound.left,
                rootWidth = _rootWrapper$getBound.width,
                rootHeight = _rootWrapper$getBound.height;

            info.left = 0 - left + rootLeft + (rootWidth - width) / 2;
            info.top = 0 - top + rootTop + (rootHeight - height) / 2;
        } else {
            if (w < maxWidth) {
                info.left = (maxWidth - w) / 2;
            }
            if (h < maxHeight) {
                info.top = (maxHeight - h) / 2;
            }
        }
        objImg.style.left = info.left + 'px';
        objImg.style.top = info.top + 'px';
        objImg.style.transform = 'rotate(' + rotate + 'deg)';
        return info;
    },
    getTransitionKeys: function getTransitionKeys() {
        if (translateKeys) {
            return translateKeys;
        }
        var testStyle = document.createElement("DIV").style;
        var me = {};
        if ("-webkit-transform" in testStyle) {
            me.transitionend = "webkitTransitionEnd";
            me.transform = "WebkitTransform";
            me.cssTransform = "-webkit-transform";
            me.transition = "WebkitTransition";
        } else if ("-ms-transform" in testStyle) {
            me.transitionend = "msTransitionEnd";
            me.transform = "msTransform";
            me.cssTransform = "-ms-transform";
            me.transition = "msTransition";
        } else {
            me.transitionend = "transitionend";
            me.transform = "transform";
            me.cssTransform = "transform";
            me.transition = "transition";
        }
        translateKeys = me;
        return me;
    },
    throttle: function throttle(func, wait, options) {
        var context, args, result;
        var timeout = null;
        var previous = 0;
        if (!options) options = {};
        var later = function later() {
            previous = options.leading === false ? 0 : new Date().valueOf();;
            timeout = null;
            result = func.apply(context, args);
            if (!timeout) context = args = null;
        };
        return function () {
            var now = new Date().valueOf();
            if (!previous && options.leading === false) previous = now;
            var remaining = wait - (now - previous);
            context = this;
            args = arguments;
            if (remaining <= 0 || remaining > wait) {
                clearTimeout(timeout);
                timeout = null;
                previous = now;
                result = func.apply(context, args);
                if (!timeout) context = args = null;
            } else if (!timeout && options.trailing !== false) {
                timeout = setTimeout(later, remaining);
            }
            return result;
        };
    }
};

exports.default = Re;