'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _dom = require('../../../dom');

var _dom2 = _interopRequireDefault(_dom);

require('./index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Popover = function Popover(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, Popover);

  this.show = function (params) {
    if (!params) {
      console.error('popver show方法缺少参数');
      return;
    }
    if (!params.rect) {
      console.error('popver show方法缺少rect参数');
      return;
    }
    var targetRect = params.rect;
    var popWidth = _this.root.offsetWidth;
    var popHeight = _this.root.offsetHeight;
    if (targetRect.bottom + popHeight > window.innerHeight) {
      var _top = targetRect.top - popHeight;
      if (_top >= 0) {
        _this.root.style.bottom = window.innerHeight - targetRect.top + 'px';
        _this.root.style.top = 'auto';
      } else {
        _this.root.style.top = '0px';
        _this.root.style.bottom = 'auto';
      }
    } else {
      _this.root.style.top = targetRect.bottom + 'px';
    }
    if (targetRect.left + popWidth + 30 > window.innerWidth) {
      _this.root.style.left = window.innerWidth - popWidth - 20 + 'px';
    } else {
      _this.root.style.left = targetRect.left + 'px';
    }
    _this.root.style.visibility = 'visible';
    _this.bk.style.visibility = 'visible';
    if (params.cb) {
      params.cb();
    }
  };

  this.hide = function () {
    _this.root.style.visibility = 'hidden';
    _this.bk.style.visibility = 'hidden';
  };

  this.remove = function () {
    document.body.removeChild(_this.root);
    document.body.removeChild(_this.bk);
  };

  this.root = document.createElement('DIV');
  this.bk = document.createElement('DIV');
  this.root.className = 'snk-tree-pop-root ' + (props.className || '');
  this.root.style.visibility = 'hidden';
  this.bk.className = 'snk-tree-pop-bk';
  this.bk.style.visibility = 'hidden';
  this.root.appendChild(props.content);
  document.body.appendChild(this.root);
  document.body.appendChild(this.bk);
  if (props.onBKClick) {
    _dom2.default.bind({
      type: 'click',
      dom: this.bk,
      stop: true,
      prevent: true,
      callback: function callback() {
        props.onBKClick();
      }
    });
  }
};

exports.default = Popover;