'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _treeItem = require('./treeItem');

var _treeItem2 = _interopRequireDefault(_treeItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TreeSection = function TreeSection(props) {
  (0, _classCallCheck3.default)(this, TreeSection);

  _initialiseProps.call(this);

  this.props = props;
  var _props = this.props,
      data = _props.data,
      index = _props.index,
      parentItem = _props.parentItem;

  this.isOpen = index === 1;
  this.root = document.createElement('DIV');
  this.root.className = 'snk-tree-section-wrapper';
  this.ul = document.createElement('UL');
  this.parentItem = parentItem;
  this.root.appendChild(this.ul);
  this.createLayout(data);
};

var _initialiseProps = function _initialiseProps() {
  var _this = this;

  this.setClose = function () {
    _this.isOpen = false;
    var index = _this.props.index;

    if (index > 0) {
      _this.root.style.height = '0px';
    }
  };

  this.toggle = function () {
    if (_this.isOpen) {
      _this.close();
    } else {
      _this.open();
    }
  };

  this.open = function () {
    _this.isOpen = true;
    _this.root.style.height = '0px';
    setTimeout(function () {
      _this.root.style.height = _this.ul.offsetHeight + 'px';
      setTimeout(function () {
        _this.root.style.height = 'auto';
      }, 200);
    }, 0);
  };

  this.close = function () {
    _this.isOpen = false;
    _this.root.style.height = _this.ul.offsetHeight + 'px';
    setTimeout(function () {
      _this.root.style.height = '0px';
    }, 0);
  };

  this.createLayout = function (data) {
    _this.items = [];
    var _props2 = _this.props,
        tree = _props2.tree,
        index = _props2.index,
        popover = _props2.popover,
        preDataArr = _props2.preDataArr;

    var frag = document.createDocumentFragment();
    for (var i = 0, j = data.length; i < j; i += 1) {
      var params = {
        data: data[i],
        tree: tree,
        section: _this,
        index: index,
        parentItem: _this.parentItem,
        popover: popover,
        preDataArr: preDataArr
      };
      if (tree.props.onBeforeItemCreate) {
        if (tree.props.onBeforeItemCreate(params) === false) {
          // eslint-disable-next-line
          continue;
        }
      }
      var item = new _treeItem2.default(params);
      item.parentSection = _this;
      _this.items.push(item);
      frag.appendChild(item.root);
    }
    _this.ul.appendChild(frag);
    if (index !== 1) {
      _this.setClose();
    }
  };
};

exports.default = TreeSection;