'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _dom = require('../dom');

var _dom2 = _interopRequireDefault(_dom);

var _tree = require('./tree');

var _tree2 = _interopRequireDefault(_tree);

var _popover = require('./components/popover');

var _popover2 = _interopRequireDefault(_popover);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PopTree = function PopTree(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, PopTree);

  this.createTree = function () {
    var _onItemClick = _this.props.onItemClick;

    _this.treeInstance = new _tree2.default((0, _extends3.default)({}, _this.props, {
      popover: _this,
      onItemClick: function onItemClick(params) {
        _this.setText(params.data.label || '');
        if (_onItemClick) {
          _onItemClick(params);
        }
      }
    }));
    return _this.treeInstance.root;
  };

  this.setText = function (text) {
    _this.text.innerHTML = text;
    _this.text.setAttribute('title', text);
  };

  this.hide = function () {
    _this.popInstance.hide();
  };

  this.show = function () {
    _this.popInstance.show({
      rect: _this.root.getBoundingClientRect()
    });
  };

  this.setSelected = function (nodeInstance) {
    if (_this.selectedNode) {
      _this.selectedNode.unSelect();
    }
    nodeInstance.select();
    _this.setText(nodeInstance.props.data.label || '');
  };

  this.getSelectedNode = function () {
    return _this.treeInstance.getSelectedNode();
  };

  this.loadData = function () {
    _this.treeInstance.loadData({
      success: function success(res) {
        if (res.data.length > 0) {
          _this.setText(res.data[0].label);
        } else {
          _this.setText('无相关数据');
        }
      }
    });
  };

  this.props = props || {};
  var _props = this.props,
      wrapper = _props.wrapper,
      className = _props.className,
      popClassName = _props.popClassName;

  if (!wrapper) {
    console.error('SNKTree 构造函数缺少wrapper字段');
  }
  this.offset = 10;
  this.root = document.createElement('DIV');
  var classNameArr = ['snk-poptree-root'];
  if (className) {
    classNameArr.push(className);
  }
  this.root.className = classNameArr.join(' ');
  wrapper.appendChild(this.root);
  var poplayerClassName = ['snk-tree-pop'];
  if (popClassName) {
    poplayerClassName.push(popClassName);
  }
  this.popInstance = new _popover2.default({
    className: poplayerClassName.join(' '),
    onBKClick: function onBKClick() {
      _this.hide();
    },
    content: this.createTree()
  });
  _dom2.default.bind({
    type: 'click',
    dom: this.root,
    callback: function callback() {
      _this.show();
    }
  });

  this.text = document.createElement('SPAN');
  this.text.className = 'snk-poptree-root-text';
  this.root.appendChild(this.text);
};

exports.default = PopTree;