'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _treeSection = require('./components/treeSection');

var _treeSection2 = _interopRequireDefault(_treeSection);

require('./index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SNKTree = function SNKTree(props) {
  var _this = this;

  (0, _classCallCheck3.default)(this, SNKTree);

  this.getUniqueSeed = function () {
    _this.seed += 1;
    return 'id-' + _this.seed;
  };

  this.setSelected = function (nodeInstance) {
    if (_this.selectedNode) {
      _this.selectedNode.unSelect();
    }
    nodeInstance.select();
  };

  this.getSelectedNode = function () {
    return _this.selectedNode;
  };

  this.loadData = function (config) {
    _this.props.loadData({
      success: function success(params) {
        _this.createLayout(params.data);
        if (config && config.success) {
          config.success({
            data: params.data
          });
        }
      },
      error: function error() {}
    });
  };

  this.beforeLabelCreate = function (params) {
    if (_this.props.onBeforeLabelCreate) {
      _this.props.onBeforeLabelCreate(params);
    }
  };

  this.createLayout = function (data) {
    var popover = _this.props.popover;

    _this.section = new _treeSection2.default({
      tree: _this,
      data: data,
      index: 0,
      popover: popover
    });
    _this.root.innerHTML = '';
    _this.root.appendChild(_this.section.root);
  };

  this.props = props || {};
  this.seed = 1;
  this.nodeDict = {};
  var wrapper = this.props.wrapper;

  if (!wrapper) {
    console.error('SNKTree 构造函数缺少wrapper字段');
  }
  this.offset = 10;
  this.root = document.createElement('DIV');
  this.root.className = 'snk-tree-root';
  wrapper.appendChild(this.root);
};

exports.default = SNKTree;