'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _lynnlinLibs = require('lynnlin-libs');

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var httpClient = new _lynnlinLibs.HttpClient();

var HttpUtils = function () {
  function HttpUtils() {
    (0, _classCallCheck3.default)(this, HttpUtils);
  }

  (0, _createClass3.default)(HttpUtils, null, [{
    key: '_createUrl',
    value: function _createUrl(params) {
      var server = params.server || SERVER;
      var url = typeof params === 'string' ? params : params.url;
      return server + url;
    }
  }, {
    key: 'post',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(params) {
        var uri, request, response;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // url, body
                uri = HttpUtils._createUrl(params);
                request = HttpUtils._createRequest(params.body);

                request.headers = params.headers || {};
                _context.next = 5;
                return httpClient.post(uri, request);

              case 5:
                response = _context.sent;
                return _context.abrupt('return', HttpUtils._processResponse(response));

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function post(_x) {
        return _ref.apply(this, arguments);
      }

      return post;
    }()
  }, {
    key: 'get',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(params) {
        var uri, request, response;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                uri = HttpUtils._createUrl(params);

                if (params.body) uri += '?' + _querystring2.default.stringify(params.body);
                request = {
                  headers: {
                    Seq: HttpUtils._seq += 1
                  }
                };

                request.headers = params.headers || {};
                _context2.next = 6;
                return httpClient.get(uri, request);

              case 6:
                response = _context2.sent;
                return _context2.abrupt('return', HttpUtils._processResponse(response));

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function get(_x2) {
        return _ref2.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'put',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(params) {
        var uri, request, response;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                uri = HttpUtils._createUrl(params);
                request = HttpUtils._createRequest(params.body);
                _context3.next = 4;
                return httpClient.put(uri, request);

              case 4:
                response = _context3.sent;
                return _context3.abrupt('return', HttpUtils._processResponse(response));

              case 6:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function put(_x3) {
        return _ref3.apply(this, arguments);
      }

      return put;
    }()
  }, {
    key: 'delete',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(params) {
        var uri, request, response;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                uri = HttpUtils._createUrl(params);
                request = HttpUtils._createRequest(params.body);
                _context4.next = 4;
                return httpClient.delete(uri, request);

              case 4:
                response = _context4.sent;
                return _context4.abrupt('return', HttpUtils._processResponse(response));

              case 6:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function _delete(_x4) {
        return _ref4.apply(this, arguments);
      }

      return _delete;
    }()
  }, {
    key: 'upload',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(params) {
        var uri, request, response;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                // url body pcb
                uri = HttpUtils._createUrl(params);
                request = HttpUtils._createRequest(params.body);
                _context5.next = 4;
                return httpClient.upload(uri, request, params.pcb, { async: true });

              case 4:
                response = _context5.sent;
                return _context5.abrupt('return', HttpUtils._processResponse(response));

              case 6:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function upload(_x5) {
        return _ref5.apply(this, arguments);
      }

      return upload;
    }()
  }, {
    key: 'formSubmit',
    value: function formSubmit(params) {
      var uri = HttpUtils._createUrl(params);
      var body = params.body;

      var iframe = document.createElement('iframe');
      iframe.setAttribute('style', 'display:none');
      iframe.setAttribute('name', 'export_iframe');
      document.body.appendChild(iframe);
      var form = document.createElement('form');
      form.setAttribute('style', 'display:none');
      form.setAttribute('target', 'export_iframe');
      form.setAttribute('method', 'post');
      form.setAttribute('enctype', 'multipart/form-data');
      form.setAttribute('action', uri);
      if (body) {
        (0, _keys2.default)(body).forEach(function (key) {
          var element = body[key];
          var input = document.createElement('input');
          input.setAttribute('style', 'display:none');
          input.setAttribute('type', 'hidden');
          input.setAttribute('name', key);
          input.setAttribute('value', element);
          form.appendChild(input);
        });
      }

      document.body.appendChild(form);
      form.submit();
    }
  }, {
    key: '_createRequest',
    value: function _createRequest(body) {
      var request = {
        headers: {
          Seq: HttpUtils._seq += 1
        },
        body: body
      };
      return request;
    }
  }, {
    key: '_processResponse',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(response) {
        var json, code, message, data, err;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return response.json();

              case 2:
                json = _context6.sent;
                code = json.code, message = json.message, data = json.data;

                if (!(code !== 0)) {
                  _context6.next = 9;
                  break;
                }

                err = { code: code, message: message };
                throw err;

              case 9:
                return _context6.abrupt('return', data);

              case 10:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _processResponse(_x6) {
        return _ref6.apply(this, arguments);
      }

      return _processResponse;
    }()
  }]);
  return HttpUtils;
}();

HttpUtils._seq = 0;
exports.default = HttpUtils;