class SNKDOM {
  setJquery = ($) => {
    this.$ = $;
  }

  bind = (config) => {
    const {
      dom, type, callback, stop, prevent,
    } = config;
    if (dom.addEventListener) {
      dom.addEventListener(type, (e) => {
        if (stop) {
          e.stopPropagation();
        }
        if (prevent) {
          e.preventDefault();
        }
        callback(e);
      });
    } else if (!this.$) {
      dom.attachEvent(`on${type}`, (e) => {
        if (stop) {
          window.event.returnValue = false;
        }
        if (prevent) {
          window.event.returnValue = false;
        }
        callback(e);
      });
    } else {
      this.$(dom).bind(type, (e) => {
        if (stop) {
          e.stopPropagation();
        }
        if (prevent) {
          e.preventDefault();
        }
        callback(e);
      });
    }
  }
}

export default new SNKDOM();
