import ThumbItem from './thumbItem';

export default class ThumbBar {
    constructor(props) {
        this.props = props || {};
        let {itemsWrapper,postion,wrapper} = this.props;
        if(['bottom','left','top','right'].indexOf(postion)<0) {
            postion = 'left';
        }
        this.thumbWrapper = document.createElement("DIV");
        this.thumbWrapper.className = `snk-slide-thumb-wrapper snk-slide-thumb-wrapper-${postion}`;
        itemsWrapper.className = `snk-slide-item-wrapper-${postion}`;
        wrapper.appendChild(this.thumbWrapper);
        this.itemsArr = [];
    }

    onChange = (params)=>{
        const selectedIndex = params.index;
        for(let i = 0, j = this.itemsArr.length; i < j; i += 1) {
            this.itemsArr[i].setSelected(i === selectedIndex);
        }
    }

    getThumbItemByIndex = (index) => {
      return this.itemsArr[index];
    }
    
    show = (props) => {
        const {data} = props;
        if(data.length === 0) {
            return;
        }
        this.thumbWrapper.innerHTML = '';
        this.itemsArr = [];
        for(let i = 0,j = data.length; i < j; i += 1) {
            const item = new ThumbItem({
                data: data[i],
                bar:this,
                slide:this.props.slide,
                wrapper:this.thumbWrapper,
            });
            this.itemsArr.push(item);
            this.thumbWrapper.appendChild(item.root);
        }
    }
}