import SNKDom from '../../dom';
import util from '../util';

const defaultSrcDict = {
    // pdf: require('../../snkpcimgs/FileExt_pdf.png'),
    // media: require('../../snkpcimgs/FileExt_pdf.png'),
    // other:require('../../snkpcimgs/FileExt_pdf.png'),
};
export default class ThumbItem {
    constructor(props){
        this.props = props;
        this.root = document.createElement("DIV");
        this.root.className = 'snk-slide-thumb-item';
        this.loadSuccess = false;
        SNKDom.bind({
            type: 'click',
            dom: this.root,
            callback: () => {
                this.props.slide.changeByDataItem(this.props.data);
            },
        });
        setTimeout(()=>{
            this.init();
        },20);
    }
    setStyle = (style) => {
        for(var key in style) {
            this.root.style[key] = style[key];
        }
    }
    setSelected = (selected)=>{
        if(selected){
            setTimeout(()=>{
              if(this.root.scrollIntoViewIfNeeded) {
                this.root.scrollIntoViewIfNeeded();
              }else {
                  this.root.scrollIntoView();
              }
            },100);
        }
        this.root.className = selected? 'snk-slide-thumb-item snk-slide-thumb-item-selected' : 'snk-slide-thumb-item';
    }
    bind = () => {
        if(this.loadSuccess) {
            return;
        }
        this.img = new Image();
        this.img.className ='snk-slide-thumb-img';
        this.img.src = this.src;
        this.img.style.transform = `rotate(${this.rotateValue}deg)`;
        this.img.onload = () => {
            this.root.innerHTML = '';
            this.root.appendChild(this.img);
        }
    }
    rotate = (value) => {
      this.rotateValue = this.rotateValue + value;
      if(this.rotateValue >= 360) {
        this.rotateValue = 0;
      }
      if(this.rotateValue === -90) {
        this.rotateValue = 270;
      }
      this.img.style.transform = `rotate(${this.rotateValue}deg)`;
    }
    init = ()=>{
        const { slide } = this.props;
        this.data = this.props.data || {};
        const { item } = this.data;
        const { snkrotateValue } = item.Vo;
        this.rotateValue = snkrotateValue || 0;
        let src = this.data.src || '';
        if(slide.props.getSrc){
          src = slide.props.getSrc({
            data: this.data,
          });
        }
        let thumbSrc = this.data.thumbSrc;
        if(slide.props.getThumb){
          thumbSrc = slide.props.getThumb({
            data: this.data,
          });
        }
        this.needLazyLoad = false;
        let subfix;
        const srcArr = src.split(".");
        subfix = srcArr[srcArr.length - 1].toLowerCase();
        subfix = subfix.split('?')[0];
        if(slide.props.getFileType) {
          const type = slide.props.getFileType({
            src,
            subfix,
            data: this.data,
          });
          if(type) {
            subfix = type;
          }
        }
        let imgSrc = thumbSrc;
        if(['jpg','png','gif','jpeg','bmp'].indexOf(subfix)>=0) {
            imgSrc = imgSrc || src;
            if(imgSrc) {
                this.needLazyLoad = true;
            }
            this.src = imgSrc;
        } else if (['pdf'].indexOf(subfix)>=0) {
            this.src = imgSrc || defaultSrcDict[subfix];
        } else if (['mp4','rmvb','mov'].indexOf(subfix)>=0) {
            this.src = imgSrc || defaultSrcDict['media'];
        } else {
            this.src = imgSrc || defaultSrcDict['other'];
        }
        if(this.src) {
            if(!imgSrc) {
                this.root.style.background = `url(${this.src}) no-repeat center center`;
                this.root.style.backgroundSize = `80px 80px`;
            }else {
                this.bind();
            }
        }
    }
    // 
}