import Tree from './tree';
import PopTree from './popTree';

class SNKTree {
  constructor(props) {
    this.treeInstance = null;
    if (props.type === 'popover') {
      this.treeInstance = new PopTree(props);
    } else {
      this.treeInstance = new Tree(props);
    }
  }

  show = (params) => {
    this.treeInstance.show(params);
  }

  setSelected = (params) => {
    this.treeInstance.setSelected(params);
  }

  loadData = (params) => {
    this.treeInstance.loadData(params);
  }

  getSelectedNode= () => {
    return this.treeInstance.getSelectedNode();
  }

  hide = () => {
    this.treeInstance.hide();
  }
}

export default SNKTree;
