import TreeSection from './components/treeSection';
import './index.less';

class SNKTree {
  constructor(props) {
    this.props = props || {};
    this.seed = 1;
    this.nodeDict = {};
    const { wrapper } = this.props;
    if (!wrapper) {
      console.error('SNKTree 构造函数缺少wrapper字段');
    }
    this.offset = 10;
    this.root = document.createElement('DIV');
    this.root.className = 'snk-tree-root';
    wrapper.appendChild(this.root);
  }

  getUniqueSeed = () => {
    this.seed += 1;
    return `id-${this.seed}`;
  }

  setSelected = (nodeInstance) => {
    if (this.selectedNode) {
      this.selectedNode.unSelect();
    }
    nodeInstance.select();
  }

  getSelectedNode = () => {
    return this.selectedNode;
  }

  loadData = (config) => {
    this.props.loadData({
      success: (params) => {
        this.createLayout(params.data);
        if (config && config.success) {
          config.success({
            data: params.data,
          });
        }
      },
      error: () => {

      },
    });
  }

  beforeLabelCreate = (params) => {
    if (this.props.onBeforeLabelCreate) {
      this.props.onBeforeLabelCreate(params);
    }
  }

  createLayout = (data) => {
    const { popover } = this.props;
    this.section = new TreeSection({
      tree: this,
      data,
      index: 0,
      popover,
    });
    this.root.innerHTML = '';
    this.root.appendChild(this.section.root);
  }
}

export default SNKTree;
